/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : FATM1.h
**     Project     : ProcessorExpert
**     Processor   : MK60DN512ZVMD10
**     Component   : FatFsMemSDHC
**     Version     : Component 01.044, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-07-27, 20:21, # CodeGen: 364
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         CardPresent      - bool FATM1_CardPresent(void);
**         isWriteProtected - bool FATM1_isWriteProtected(void);
**         Init             - LDD_TDeviceData* FATM1_Init(LDD_TUserData *UserDataPtr);
**         Deinit           - void FATM1_Deinit(LDD_TDeviceData *DeviceDataPtr);
**         Activate         - void FATM1_Activate(void);
**         Deactivate       - void FATM1_Deactivate(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software using Processor Expert.
**     This is a free software and is opened for education,  research and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

#ifndef __FATM1_H
#define __FATM1_H

/* MODULE FATM1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "GPIO2.h"
#include "SDHC1.h"
#include "TMOUT1.h"

#include "Cpu.h"

typedef struct {
  LDD_TDeviceData *SDHCPtr;     /* SDHC component data */
  LDD_TDeviceData *GPIOPtr;     /* GPIO component data */
  bool Finished;                /* Operation end indication */
  bool Inserted;                /* Card insertion indication */
  uint8_t CardId;               /* Initialized card ID */
  LDD_SDHC_TCardInfo CardInfo;  /* Initialized card info */
} TSDData;

#define FATM1_BLOCK_SIZE   512            /* user defined block size */





void SDHC1_OnCardInserted(LDD_TUserData *UserDataPtr, uint8_t Id);

void SDHC1_OnCardRemoved(LDD_TUserData *UserDataPtr, uint8_t Id);

void SDHC1_OnFinished(LDD_TUserData *UserDataPtr);

bool FATM1_CardPresent(void);
/*
** ===================================================================
**     Method      :  FATM1_CardPresent (component FatFsMemSDHC)
**
**     Description :
**         Returns TRUE if card is present
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

void GPIO2_OnPortEvent(LDD_TUserData *UserDataPtr);

LDD_TDeviceData* FATM1_Init(LDD_TUserData *UserDataPtr);
/*
** ===================================================================
**     Method      :  FATM1_Init (component FatFsMemSDHC)
**
**     Description :
**         Initialization method
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to RTOS structure
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

void FATM1_Deinit(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  FATM1_Deinit (component FatFsMemSDHC)
**
**     Description :
**         Method to denitialize the device driver
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Pointer to RTOS
**                           structure
**     Returns     : Nothing
** ===================================================================
*/

void FATM1_Activate(void);
/*
** ===================================================================
**     Method      :  FATM1_Activate (component FatFsMemSDHC)
**
**     Description :
**         Activates the communication channel
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void FATM1_Deactivate(void);
/*
** ===================================================================
**     Method      :  FATM1_Deactivate (component FatFsMemSDHC)
**
**     Description :
**         Deactivates the communication channel
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

bool FATM1_isWriteProtected(void);
/*
** ===================================================================
**     Method      :  FATM1_isWriteProtected (component FatFsMemSDHC)
**
**     Description :
**         Returns TRUE if card is write protected
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

/* END FATM1. */

#endif
/* ifndef __FATM1_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
