/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : FSSH1.c
**     Project     : ProcessorExpert
**     Processor   : MK60DN512ZVMD10
**     Component   : FSShell
**     Version     : Component 01.220, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-07-29, 21:34, # CodeGen: 369
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         PrintPrompt        - void FSSH1_PrintPrompt(FSSH1_ConstStdIOType *io);
**         SendNum8u          - void FSSH1_SendNum8u(byte val, FSSH1_StdIO_OutErr_FctType io);
**         SendNum8s          - void FSSH1_SendNum8s(signed char val, FSSH1_StdIO_OutErr_FctType io);
**         SendNum16u         - void FSSH1_SendNum16u(word val, FSSH1_StdIO_OutErr_FctType io);
**         SendNum16s         - void FSSH1_SendNum16s(int16_t val, FSSH1_StdIO_OutErr_FctType io);
**         SendNum32u         - void FSSH1_SendNum32u(dword val, FSSH1_StdIO_OutErr_FctType io);
**         SendNum32s         - void FSSH1_SendNum32s(long val, FSSH1_StdIO_OutErr_FctType io);
**         SendStr            - void FSSH1_SendStr(const byte *str, FSSH1_StdIO_OutErr_FctType io);
**         PrintDirectory     - byte FSSH1_PrintDirectory(const byte *dirName, FSSH1_ConstStdIOType *io);
**         CopyFile           - byte FSSH1_CopyFile(const byte *srcFileName, const byte *dstFileName,...
**         DeleteFile         - byte FSSH1_DeleteFile(const byte *fileName, FSSH1_ConstStdIOType *io);
**         PrintFile          - byte FSSH1_PrintFile(const byte *fileName, FSSH1_ConstStdIOType *io);
**         MakeDirectory      - byte FSSH1_MakeDirectory(const byte *dirName, FSSH1_ConstStdIOType *io);
**         ChangeDirectory    - byte FSSH1_ChangeDirectory(const byte *dirName, FSSH1_ConstStdIOType *io);
**         RenameFile         - byte FSSH1_RenameFile(const byte *srcFileName, const byte *dstFileName,...
**         UnMountFileSystem  - byte FSSH1_UnMountFileSystem(byte logicalDrive, FSSH1_ConstStdIOType *io);
**         MountFileSystem    - byte FSSH1_MountFileSystem(FSSH1_FATFS *fileSystemObject, byte logicalDrive,...
**         CheckCardPresence  - byte FSSH1_CheckCardPresence(bool *cardMounted, byte drive, FSSH1_FATFS...
**         PrintDiskInfo      - byte FSSH1_PrintDiskInfo(byte drive, FSSH1_ConstStdIOType *io);
**         Date               - byte FSSH1_Date(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
**         Time               - byte FSSH1_Time(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
**         PrintStatus        - byte FSSH1_PrintStatus(FSSH1_ConstStdIOType *io);
**         ShellCmd           - byte FSSH1_ShellCmd(const unsigned char *cmd, bool *handled,...
**         ReadLine           - bool FSSH1_ReadLine(byte *buf, size_t bufSize, FSSH1_ConstStdIOType *io);
**         PrintCommandFailed - void FSSH1_PrintCommandFailed(const unsigned char *cmd, FSSH1_ConstStdIOType...
**         ParseCommand       - byte FSSH1_ParseCommand(const unsigned char *cmd, FSSH1_ConstStdIOType *io,...
**         GetStdio           - FSSH1_ConstStdIOTypePtr FSSH1_GetStdio(void);
**         ReadAndParseCmd    - byte FSSH1_ReadAndParseCmd(byte *cmdBuf, size_t cmdBufSize,...
**         RequestSerial      - void FSSH1_RequestSerial(void);
**         ReleaseSerial      - void FSSH1_ReleaseSerial(void);
**         GetSemaphore       - void* FSSH1_GetSemaphore(void);
**         SendStatusStr      - void FSSH1_SendStatusStr(const byte *strItem, const byte *strStatus,...
**         SendHelpStr        - void FSSH1_SendHelpStr(const byte *strCmd, const byte *strHelp,...
**         ReadChar           - void FSSH1_ReadChar(byte *c);
**         SendChar           - void FSSH1_SendChar(byte ch);
**         KeyPressed         - bool FSSH1_KeyPressed(void);
**         Init               - void FSSH1_Init(void);
**         Deinit             - void FSSH1_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software implementing a shell using Processor Expert.
**     Main purpose is for a file system, but useful as well without one.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE FSSH1. */

#include "FSSH1.h"
#if FAT1_USE_LFN == 0                   /* No LFN */
#define FSSH1_DEF_NAMEBUF(name)         byte name[FSSH1_8_3_SIZE]
#define FSSH1_PTR_NAMEBUF(name)         &name[0]
#define FSSH1_SIZE_NAMEBUF(name)        sizeof(name)
#define FSSH1_INIT_NAMEBUF(name)
#define FSSH1_FREE_NAMEBUF(name)

#elif FAT1_USE_LFN == 1                 /* LFN with static LFN working buffer */
static TCHAR FSSH1_FileName[FAT1_MAX_LFN+1];
static TCHAR FSSH1_FileName2[FAT1_MAX_LFN+1];
#define FSSH1_DEF_NAMEBUF(name)
#define FSSH1_PTR_NAMEBUF(name)         &FSSH1_name[0]
#define FSSH1_SIZE_NAMEBUF(name)        sizeof(FSSH1_name)
#define FSSH1_INIT_NAMEBUF(name)
#define FSSH1_FREE_NAMEBUF(name)

#elif FAT1_USE_LFN == 2                 /* LFN with dynamic LFN working buffer on the stack */
#define FSSH1_DEF_NAMEBUF(name)         byte name[FAT1_MAX_LFN+1]
#define FSSH1_PTR_NAMEBUF(name)         &name[0]
#define FSSH1_SIZE_NAMEBUF(name)        sizeof(name)
#define FSSH1_INIT_NAMEBUF(name)
#define FSSH1_FREE_NAMEBUF(name)

#elif FAT1_USE_LFN == 3                 /* LFN with dynamic LFN working buffer on the heap */
#define FSSH1_DEF_NAMEBUF(name)         byte *name
#define FSSH1_PTR_NAMEBUF(name)         name
#define FSSH1_SIZE_NAMEBUF(name)        (FAT1_MAX_LFN+1)
#define FSSH1_INIT_NAMEBUF(name)        { name = ff_memalloc(FAT1_MAX_LFN+1); \
                                          if (!name) { \
                                            FSSH1_SendStr((unsigned char*)"ff_memalloc failed!", io->stdErr); \
                                            return ERR_FAILED; \
                                          } \
                                        }
#define FSSH1_FREE_NAMEBUF(name)        ff_memfree(name)

#else
#error Wrong LFN configuration.
#endif

#include <stdio.h>

#ifdef __HC08__
  #pragma MESSAGE DISABLE C3303 /* implicit concatenation of strings */
#endif
static xSemaphoreHandle ShellSem = NULL; /* Semaphore to protect shell SCI access */
static LDD_TDeviceData *serialHandle = NULL; /* handle to device data */
static unsigned char serialRxBuf[32]; /* circular RX buffer */
static unsigned char serialRxInIdx; /* input index into buffer */
static unsigned char serialRxOutIdx; /* input index into buffer */
static volatile uint8_t FSSH1_SentFlag = 0; /* this will be set to 1 once the block has been sent */
/* Internal method prototypes */
static void FatFsDResultMsg(byte *msg, FSSH1_DRESULT errNo, FSSH1_ConstStdIOType *io);
static void FatFsFResultMsg(byte *msg, FSSH1_FRESULT errNo, FSSH1_ConstStdIOType *io);
static byte PrintDir(const byte *dirPathPtr, FSSH1_ConstStdIOType *io);
static void CmdUsageError(const unsigned char *cmd, byte *usage, FSSH1_ConstStdIOType *io);
static byte DirCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte CopyCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte DeleteCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte MkdirCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte RenameCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte SectorCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte PrintCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte CdCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io);
static byte AddSWRTCDate(byte *buf, word bufSize);
static byte AddSWRTCTime(byte *buf, word bufSize);
static void SendSeparatedStrings(const byte *strA, const byte *strB, byte tabChar, byte tabPos, FSSH1_StdIO_OutErr_FctType io);

/*
** ===================================================================
**     Method      :  FSSH1_SendStr (component FSShell)
**
**     Description :
**         Prints a string using an I/O function
**     Parameters  :
**         NAME            - DESCRIPTION
**         str             - String (zero terminated) to be printed.
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
/*!
 * \brief Prints a string using I/O callbacks
 * \param[in] str String (zero terminated) to be printed
 * \param[in] io I/O function to be used for printing
 */
void FSSH1_SendStr(const byte *str, FSSH1_StdIO_OutErr_FctType io)
{
  while(*str!='\0') {
    io(*str++);
  }
}

/*
** ===================================================================
**     Method      :  FSSH1_SendNum32s (component FSShell)
**
**     Description :
**         Sends a 32bit signed number to the given I/O
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - number to print
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendNum32s(long val, FSSH1_StdIO_OutErr_FctType io)
{
  unsigned char buf[sizeof("-1234567890")];

  UTIL1_Num32sToStr(buf, sizeof(buf), val);
  FSSH1_SendStr(buf, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendNum32u (component FSShell)
**
**     Description :
**         Sends a 32bit unsigned number to the given I/O
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - number to print
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendNum32u(dword val, FSSH1_StdIO_OutErr_FctType io)
{
  unsigned char buf[sizeof("1234567890")];

  UTIL1_Num32uToStr(buf, sizeof(buf), val);
  FSSH1_SendStr(buf, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendNum16s (component FSShell)
**
**     Description :
**         Sends a 16bit signed number to the given I/O
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - number to print
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendNum16s(int16_t val, FSSH1_StdIO_OutErr_FctType io)
{
  unsigned char buf[sizeof("-12345")];

  UTIL1_Num16sToStr(buf, sizeof(buf), val);
  FSSH1_SendStr(buf, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendNum16u (component FSShell)
**
**     Description :
**         Sends a 16bit unsigned number to the given I/O
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - number to print
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendNum16u(word val, FSSH1_StdIO_OutErr_FctType io)
{
  unsigned char buf[sizeof("12345")];

  UTIL1_Num16uToStr(buf, sizeof(buf), val);
  FSSH1_SendStr(buf, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendNum8u (component FSShell)
**
**     Description :
**         Sends an 8bit unsigned number to the given I/O
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - number to print
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendNum8u(byte val, FSSH1_StdIO_OutErr_FctType io)
{
  unsigned char buf[sizeof("123")];

  UTIL1_Num8uToStr(buf, sizeof(buf), val);
  FSSH1_SendStr(buf, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendNum8s (component FSShell)
**
**     Description :
**         Sends an 8bit signed number to the given I/O
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - number to print
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendNum8s(signed char val, FSSH1_StdIO_OutErr_FctType io)
{
  unsigned char buf[sizeof("-123")];

  UTIL1_Num8sToStr(buf, sizeof(buf), val);
  FSSH1_SendStr(buf, io);
}

/*
** ===================================================================
**     Method      :  FatFsFResultMsg (component FSShell)
**
**     Description :
**         Called in case of an error using FatFS for a FRESULT return
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void FatFsFResultMsg(byte *msg, FSSH1_FRESULT errNo, FSSH1_ConstStdIOType *io)
{
  unsigned char buf[sizeof("1234")];

  FSSH1_SendStr((unsigned char*)"ERROR: ", io->stdErr);
  FSSH1_SendStr(msg, io->stdErr);
  FSSH1_SendStr((unsigned char*)": (", io->stdErr);
  UTIL1_Num16sToStr(buf, sizeof(buf), errNo);
  FSSH1_SendStr(buf, io->stdErr);
  FSSH1_SendStr((unsigned char*)") ", io->stdErr);
  FSSH1_SendStr((unsigned char*)FAT1_errFResultMsg(errNo), io->stdErr);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdErr);
}

/*
** ===================================================================
**     Method      :  FatFsDResultMsg (component FSShell)
**
**     Description :
**         Called in case of an error using FatFS for a DRESULT return
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void FatFsDResultMsg(byte *msg, FSSH1_DRESULT errNo, FSSH1_ConstStdIOType *io)
{
  unsigned char buf[sizeof("1234")];

  FSSH1_SendStr((unsigned char*)"ERROR: ", io->stdErr);
  FSSH1_SendStr(msg, io->stdErr);
  FSSH1_SendStr((unsigned char*)": (", io->stdErr);
  UTIL1_Num16sToStr(buf, sizeof(buf), errNo);
  FSSH1_SendStr(buf, io->stdErr);
  FSSH1_SendStr((unsigned char*)") ", io->stdErr);
  FSSH1_SendStr((unsigned char*)FAT1_errDResultMsg(errNo), io->stdErr);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdErr);
}

/*
** ===================================================================
**     Method      :  PrintDir (component FSShell)
**
**     Description :
**         Prints a directory listing
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
/*!
 * \brief Writes a directory listing of the given path
 * \param[in] dirPathPtr Pointer to a directory path string. Pass "\\" for the root directory
 * \param[in] io Callback to write directory output
 * \return Error code, otherwise ERR_OK
 */
static byte PrintDir(const byte *dirPathPtr, FSSH1_ConstStdIOType *io)
{
  FAT1_FILINFO fInfo;
  FAT1_FRESULT fres;
  uint32_t p1;
  UINT s1, s2;
  DWORD sect = 0;
  FAT1_DIR dir;  /* Directory object */
  byte buf[sizeof("yyyy-mm-dd hh:ss")+1];
#if !FAT1_FS_READONLY
  FAT1_FATFS *fs;
#endif
#if FAT1_USE_LFN
  FSSH1_DEF_NAMEBUF(fileName);
#endif

  FSSH1_SendStr((unsigned char*)"Directory of ", io->stdOut);
  FSSH1_SendStr(dirPathPtr, io->stdOut);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  fres = FAT1_opendir(&dir, (char*)dirPathPtr);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"opendir failed", fres, io);
    return ERR_FAULT;
  }
  p1 = s1 = s2 = 0;
#if FAT1_USE_LFN
  FSSH1_INIT_NAMEBUF(fileName);
  fInfo.lfname = (char*)fileName;
  fInfo.lfsize = FSSH1_SIZE_NAMEBUF(fileName);
#endif
  for(;;) {
    fres = FAT1_readdir(&dir, &fInfo);
    if (fres != FR_OK) {
      FatFsFResultMsg((unsigned char*)"readdir failed", fres, io);
      break;
    }
    if (!fInfo.fname[0]) { /* end of directory list */
      break;
    }
    /* file attributes */
    if (fInfo.fattrib & AM_DIR) { /* directory */
      s2++;
      io->stdOut('D');
    } else {
      s1++;
      p1 += fInfo.fsize;
      io->stdOut('-');
    }
    if (fInfo.fattrib & AM_RDO) { /* read only */
      io->stdOut('R');
    } else {
      io->stdOut('-');
    }
    if (fInfo.fattrib & AM_HID) { /* hidden */
      io->stdOut('H');
    } else {
      io->stdOut('-');
    }
    if (fInfo.fattrib & AM_SYS) { /* system */
      io->stdOut('S');
    } else {
      io->stdOut('-');
    }
    if (fInfo.fattrib & AM_ARC) { /* archive */
      io->stdOut('A');
    } else {
      io->stdOut('-');
    }
    io->stdOut(' ');
    /* file date & time */
    buf[0] = '\0';
    UTIL1_strcatNum16sFormatted(buf, sizeof(buf), (int16_t)((fInfo.fdate >> 9) + 1980), ' ', 4); /* year */
    UTIL1_strcat(buf, sizeof(buf), (unsigned char*)"-");
    UTIL1_strcatNum16sFormatted(buf, sizeof(buf), (int16_t)((fInfo.fdate >> 5) & 15), '0', 2); /* month */
    UTIL1_strcat(buf, sizeof(buf), (unsigned char*)"-");
    UTIL1_strcatNum16sFormatted(buf, sizeof(buf), (int16_t)(fInfo.fdate & 31), '0', 2); /* day */
    UTIL1_strcat(buf, sizeof(buf), (unsigned char*)" ");
    UTIL1_strcatNum16sFormatted(buf, sizeof(buf), (int16_t)((fInfo.ftime >> 11)), '0', 2); /* hour */
    UTIL1_strcat(buf, sizeof(buf), (unsigned char*)":");
    UTIL1_strcatNum16sFormatted(buf, sizeof(buf), (int16_t)((fInfo.ftime >> 5) & 63), '0', 2); /* minute */
    FSSH1_SendStr(buf, io->stdOut);
    io->stdOut(' ');
    buf[0] = '\0';
    /* file size */
    UTIL1_strcatNum32uFormatted(buf, sizeof(buf), fInfo.fsize, ' ', 10); /* size */
    FSSH1_SendStr(buf, io->stdOut);
    /* file name */
    io->stdOut(' ');
    FSSH1_SendStr((unsigned char*)fInfo.fname, io->stdOut);
#if FAT1_USE_LFN
    io->stdOut(' ');
    FSSH1_SendStr((unsigned char*)fInfo.lfname, io->stdOut);
#endif
    io->stdOut('\r');
    io->stdOut('\n');
  }
  /* number of files and bytes used */
  buf[0] = '\0';
  UTIL1_strcatNum16u(buf, sizeof(buf), (uint16_t)s1);
  FSSH1_SendStr(buf, io->stdOut);
  FSSH1_SendStr((unsigned char*)" File(s), ", io->stdOut);
  buf[0] = '\0';
  UTIL1_strcatNum32u(buf, sizeof(buf), p1);
  FSSH1_SendStr(buf, io->stdOut);
  FSSH1_SendStr((unsigned char*)" bytes total\r\n", io->stdOut);
  /* number of directories and number of free bytes */
  buf[0] = '\0';
  UTIL1_strcatNum16u(buf, sizeof(buf), (uint16_t)s2);
  FSSH1_SendStr(buf, io->stdOut);
  FSSH1_SendStr((unsigned char*)" Dir(s)", io->stdOut);
#if !FAT1_FS_READONLY
  /* number of free bytes */
  fres = FAT1_getfree((char*)dirPathPtr, &p1, &fs);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"getfree failed", fres, io);
  } else {
    io->stdOut(',');
    io->stdOut(' ');
    buf[0] = '\0';
    UTIL1_strcatNum32s(buf, sizeof(buf), (long)(p1*fs->csize/2));
    FSSH1_SendStr(buf, io->stdOut);
    FSSH1_SendStr((unsigned char*)" KBytes free", io->stdOut);
  }
#endif
  io->stdOut('\r');
  io->stdOut('\n');
#if FAT1_USE_LFN
  FSSH1_FREE_NAMEBUF(fileName);
#endif
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_PrintDirectory (component FSShell)
**
**     Description :
**         Prints a directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         dirName         - Directory folder to be printed
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Prints a directory listing
 * \param[in] dirName Directory to be used
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_PrintDirectory(const byte *dirName, FSSH1_ConstStdIOType *io)
{
  byte res;

  res = PrintDir(dirName, io);
  if (res != ERR_OK) {
    FSSH1_SendStr((unsigned char*)"PrintDir failed\r\n", io->stdErr);
    return res;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_CopyFile (component FSShell)
**
**     Description :
**         Copy a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         srcFileName     - Source file name
**         dstFileName     - Destination file name
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Copy the source file to a destination file
 * \param[in] srcFileName Source file name
 * \param[in] dstFileName Destination file name
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_CopyFile(const byte *srcFileName, const byte *dstFileName, FSSH1_ConstStdIOType *io)
{
#if !FAT1_FS_READONLY
  FAT1_FIL fsrc, fdst;  /* file objects */
  FAT1_FRESULT fres;
  uint8_t buffer[256];   /* copy buffer */
  UINT br, bw;          /* file read/write counters */
  byte res =  ERR_OK;

  if (FAT1_isWriteProtected()) {
    FSSH1_SendStr((unsigned char*)"disk is write protected!\r\n", io->stdErr);
    return ERR_FAILED;
  }
  /* open source file */
  fres = FAT1_open(&fsrc, (char*)srcFileName, FA_OPEN_EXISTING | FA_READ);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"open source file failed", fres, io);
    return ERR_FAILED;
  }
  /* create destination file */
  fres = FAT1_open(&fdst, (char*)dstFileName, FA_CREATE_ALWAYS | FA_WRITE);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"open destination file failed", fres, io);
    return ERR_FAILED;
  }
  /* now copy source to destination */
  for (;;) {
    fres = FAT1_read(&fsrc, buffer, sizeof(buffer), &br);
    if (fres != FR_OK) {
      FatFsFResultMsg((unsigned char*)"reading source file failed", fres, io);
      res = ERR_FAILED;
      break;
    }
    if (br == 0) { /* EOF */
      break; /* get out of loop */
    }
    fres = FAT1_write(&fdst, buffer, br, &bw);
    if (fres != ERR_OK) {
      FatFsFResultMsg((unsigned char*)"writing destination file failed", fres, io);
      res = ERR_FAILED;
      break;
    }
    if (bw < br) {
      FSSH1_SendStr((unsigned char*)"failed writing destination file, or disk full\r\n", io->stdErr);
      res = ERR_FAILED;
      break;
    }
  } /* for */
  /* close all files */
  fres = FAT1_close(&fsrc);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"closing source file failed", fres, io);
    res = ERR_FAILED;
  }
  fres = FAT1_close(&fdst);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"closing destination file failed", fres, io);
    res = ERR_FAILED;
  }
  return res;
#else
  (void)srcFileName; /* unused argument */
  (void)dstFileName; /* unused argument */
  FSSH1_SendStr((unsigned char*)"File System is in Read-Only mode\r\n", io->stdErr);
  return ERR_FAILED;
#endif
}

/*
** ===================================================================
**     Method      :  FSSH1_DeleteFile (component FSShell)
**
**     Description :
**         Deletes a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fileName        - Filename of file to be deleted
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Deletes a file
 * \param[in] fileName Name of file to be deleted
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_DeleteFile(const byte *fileName, FSSH1_ConstStdIOType *io)
{
  FAT1_FRESULT fres;

  if (FAT1_isWriteProtected()) {
    FSSH1_SendStr((unsigned char*)"disk is write protected!\r\n", io->stdErr);
    return ERR_FAILED;
  }
  fres = FAT1_unlink((char*)fileName);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"unlink failed", fres, io);
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_PrintFile (component FSShell)
**
**     Description :
**         Prints the content of a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fileName        - Name of file to be printed
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Print the content of a file
 * \param[in] fileName Name of file to be printed
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_PrintFile(const byte *fileName, FSSH1_ConstStdIOType *io)
{
  FAT1_FIL file;
  FAT1_FRESULT fres;
  UINT nofRead = 0;
  byte buf[32];
  byte res = ERR_OK;

  fres = FAT1_open(&file, (const TCHAR *)fileName, FA_READ);
  if (fres == FR_OK) {
    do {
      nofRead = 0;
      fres=FAT1_read(&file, buf, sizeof(buf)-1, &nofRead); /* read one byte less for zero byte */
      if (fres != FR_OK) {
        FSSH1_SendStr((unsigned char*)"fread failed\r\n", io->stdErr);
        res = ERR_FAILED;
      } else {
        buf[nofRead] = '\0'; /* terminate buffer */
        FSSH1_SendStr(buf, io->stdOut);
      }
    } while(nofRead>0 && fres==FR_OK);
    fres=FAT1_close(&file);
    if (fres != FR_OK) {
      FSSH1_SendStr((unsigned char*)"fclose failed\r\n", io->stdErr);
      res = ERR_FAILED;
    }
  } else {
    FatFsFResultMsg((unsigned char*)"open file failed", fres, io);
    res = ERR_FAILED;
  }
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_MakeDirectory (component FSShell)
**
**     Description :
**         Creates a directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         dirName         - Directory name
**       * io              - Pointer to I/O callback routines
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Creates a new directory
 * \param[in] dirName Name of the directory to be created
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_MakeDirectory(const byte *dirName, FSSH1_ConstStdIOType *io)
{
  FAT1_FRESULT fres;

  if (FAT1_isWriteProtected()) {
    FSSH1_SendStr((unsigned char*)"disk is write protected!\r\n", io->stdErr);
    return ERR_FAILED;
  }
  fres = FAT1_mkdir((char*)dirName);
  if(fres!=FR_OK) {
    FatFsFResultMsg((unsigned char*)"mkdir failed", fres, io);
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_RenameFile (component FSShell)
**
**     Description :
**         Renames a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         srcFileName     - Source file name
**         dstFileName     - Destination file name
**       * io              - Pointer to 
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Renames a file
 * \param[in] srcFileName Source/existing file name
 * \param[in] dstFileName Destination/new file name
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_RenameFile(const byte *srcFileName, const byte *dstFileName, FSSH1_ConstStdIOType *io)
{
  FAT1_FRESULT fres;

  if (FAT1_isWriteProtected()) {
    FSSH1_SendStr((unsigned char*)"disk is write protected!\r\n", io->stdErr);
    return ERR_FAILED;
  }
  fres = FAT1_rename((char*)srcFileName, (char*)dstFileName);
  if(fres!=FR_OK) {
    FatFsFResultMsg((unsigned char*)"rename failed", fres, io);
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_MountFileSystem (component FSShell)
**
**     Description :
**         Mounts a file system
**     Parameters  :
**         NAME            - DESCRIPTION
**       * fileSystemObject - Pointer to a
**                           file system object
**         logicalDrive    - The drive number to be
**                           used
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Mounts the file system for a drive
 * \param[in] fileSystemObject Pointer to the file system object
 * \param[in] logicalDrive The drive number to be used
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_MountFileSystem(FSSH1_FATFS *fileSystemObject, byte logicalDrive, FSSH1_ConstStdIOType *io)
{
  FAT1_FRESULT fres;

  fres = FAT1_mount(logicalDrive, fileSystemObject);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"mount failed", fres, io);
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_UnMountFileSystem (component FSShell)
**
**     Description :
**         Unmounts the file system for a drive
**     Parameters  :
**         NAME            - DESCRIPTION
**         logicalDrive    - The drive number to be
**                           used
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Unmounts the file system for a drive
 * \param[in] logicalDrive The drive number to be used
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_UnMountFileSystem(byte logicalDrive, FSSH1_ConstStdIOType *io)
{
  FAT1_FRESULT fres;

  fres = FAT1_mount(logicalDrive, NULL);
  if (fres != FR_OK) {
    FatFsFResultMsg((unsigned char*)"unmount failed", fres, io);
    return ERR_FAILED;
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_PrintDiskInfo (component FSShell)
**
**     Description :
**         Prints information about the current disk
**     Parameters  :
**         NAME            - DESCRIPTION
**         drive           - drive number, starting with zero
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*!
 * \brief Prints information about the disk
 * \param[in] drive Disk drive number, starting with zero
 * \param[in] io IO handler for output
 * \return Error code, ERR_OK for success.
 */
byte FSSH1_PrintDiskInfo(byte drive, FSSH1_ConstStdIOType *io)
{
  /* see for details:
   * http://www.retroleum.co.uk/electronics-articles/basic-mmc-card-access/
   */
  uint8_t buf[8];
  int32_t val32;
  int16_t val16;
  int8_t val8;
  uint8_t buff[64];
  uint8_t driverVersion; /* 0: SPI, 1: SDHC_LDD */

  if ((disk_initialize(drive)&STA_NOINIT)!=0) {
    FSSH1_SendStr((unsigned char*)"disk initialize failed\r\n", io->stdErr);
    return ERR_FAILED;
  }
  if (disk_ioctl(0, MMC_GET_DRIVER_VERSION, &driverVersion)!=RES_OK) {
    FSSH1_SendStr((unsigned char*)"failed identification of driver version\r\n", io->stdErr);
    return ERR_FAILED;
  }
  FSSH1_SendStatusStr((unsigned char*)"Card type", (unsigned char*)"", io->stdOut);
  if (disk_ioctl(0, MMC_GET_TYPE, &val8)==RES_OK) {
    if (val8&CT_SD1) {
      FSSH1_SendStr((unsigned char*)"SD1 ", io->stdOut);
    }
    if (val8&CT_SD2) {
      FSSH1_SendStr((unsigned char*)"SD2 ", io->stdOut);
    }
    if (val8&CT_BLOCK) {
      FSSH1_SendStr((unsigned char*)"BLOCK ", io->stdOut);
    }
    if (val8&CT_MMC) {
      FSSH1_SendStr((unsigned char*)"MMC ", io->stdOut);
    }
    if (val8&CT_SDC) {
      FSSH1_SendStr((unsigned char*)"SDC ", io->stdOut);
    }
    if (val8&CT_ATA) {
      FSSH1_SendStr((unsigned char*)"ATA ", io->stdOut);
    }
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  } else {
    FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
  }
  if (driverVersion==0) { /* only SPI cards implement this */
    FSSH1_SendStatusStr((unsigned char*)"SDC version", (unsigned char*)"", io->stdOut);
    if (disk_ioctl(0, MMC_GET_SDC_VERSION, &val8)==RES_OK) {
      if (val8==1) {
        FSSH1_SendStr((unsigned char*)"SDC ver 1.XX or MMC\r\n", io->stdOut);
      } else if (val8==2) {
        FSSH1_SendStr((unsigned char*)"SDC ver 2.00\r\n", io->stdOut);
      } else {
        FSSH1_SendStr((unsigned char*)"unknown\r\n", io->stdOut);
      }
    } else {
      FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
    }
  }
  FSSH1_SendStatusStr((unsigned char*)"Sector count", (unsigned char*)"", io->stdOut);
  if (disk_ioctl(0, GET_SECTOR_COUNT, &val32)==RES_OK) {
    UTIL1_Num32sToStr(buf, sizeof(buf), val32);
    FSSH1_SendStr(buf, io->stdOut);
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  } else {
    FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
  }
  FSSH1_SendStatusStr((unsigned char*)"Sector size", (unsigned char*)"", io->stdOut);
  if (disk_ioctl(0, GET_SECTOR_SIZE, &val16)==RES_OK) {
    UTIL1_Num16sToStr(buf, sizeof(buf), val16);
    FSSH1_SendStr(buf, io->stdOut);
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  } else {
    FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
  }
  FSSH1_SendStatusStr((unsigned char*)"READ_BL_LEN", (unsigned char*)"", io->stdOut);
  if (disk_ioctl(0, MMC_GET_READ_BL_LEN, &val16)==RES_OK) {
    UTIL1_Num16sToStr(buf, sizeof(buf), val16);
    FSSH1_SendStr(buf, io->stdOut);
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  } else {
    FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
  }
  if (driverVersion==0) { /* only SPI cards implement this */
    FSSH1_SendStatusStr((unsigned char*)"Block size", (unsigned char*)"", io->stdOut);
    if (disk_ioctl(0, GET_BLOCK_SIZE, &val32)==RES_OK) {
      UTIL1_Num32sToStr(buf, sizeof(buf), val32);
      FSSH1_SendStr(buf, io->stdOut);
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    } else {
      FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
    }
    FSSH1_SendStatusStr((unsigned char*)"CSD", (unsigned char*)"", io->stdOut);
    if (disk_ioctl(0, MMC_GET_CSD, &buff[0])==RES_OK) {
      for(val8=0; val8<16; val8++) {
        buf[0] = '\0';
        UTIL1_strcatNum8Hex(buf, sizeof(buf), (uint8_t)buff[val8]);
        FSSH1_SendStr(buf, io->stdOut);
        FSSH1_SendStr((unsigned char*)" ", io->stdOut);
      }
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    } else {
      FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
    }
    FSSH1_SendStatusStr((unsigned char*)"CID", (unsigned char*)"", io->stdOut);
    if (disk_ioctl(0, MMC_GET_CID, &buff[0])==RES_OK) {
      for(val8=0; val8<16; val8++) {
        buf[0] = '\0';
        UTIL1_strcatNum8Hex(buf, sizeof(buf), (uint8_t)buff[val8]);
        FSSH1_SendStr(buf, io->stdOut);
        FSSH1_SendStr((unsigned char*)" ", io->stdOut);
      }
      FSSH1_SendStr((unsigned char*)"\r\n               Manufacturer ", io->stdOut);
      for(val8=3; val8<=8; val8++) {
        io->stdOut(buff[val8]);
      }
      FSSH1_SendStr((unsigned char*)"\r\n               Serial Number ", io->stdOut);
      buf[0] = '\0';
      UTIL1_strcatNum32Hex(buf, sizeof(buf), (uint32_t)((buff[0xa]<<24)|(buff[0xb]<<16)|(buff[0xc]<<8)|buff[0xd]));
      FSSH1_SendStr(buf, io->stdOut);
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    } else {
      FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
    }
    FSSH1_SendStatusStr((unsigned char*)"OCR", (unsigned char*)"", io->stdOut);
    if (disk_ioctl(0, MMC_GET_OCR, &buff[0])==RES_OK) {
      for(val8=0; val8<4; val8++) {
        buf[0] = '\0';
        UTIL1_strcatNum8Hex(buf, sizeof(buf), (uint8_t)buff[val8]);
        FSSH1_SendStr(buf, io->stdOut);
        FSSH1_SendStr((unsigned char*)" ", io->stdOut);
      }
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    } else {
      FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
    }
    FSSH1_SendStatusStr((unsigned char*)"SD Status", (unsigned char*)"", io->stdOut);
    if (disk_ioctl(0, MMC_GET_SDSTAT, &buff[0])==RES_OK) {
      for(val8=0; val8<64; val8++) {
        buf[0] = '\0';
        if (val8!=0 && (val8%16)==0) { /* new line to make things readable */
          FSSH1_SendStr((unsigned char*)"\r\n               ", io->stdOut);
        }
        UTIL1_strcatNum8Hex(buf, sizeof(buf), (uint8_t)buff[val8]);
       FSSH1_SendStr(buf, io->stdOut);
       FSSH1_SendStr((unsigned char*)" ", io->stdOut);
      }
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    } else {
      FSSH1_SendStr((unsigned char*)"ERROR\r\n", io->stdOut);
    }
  }
  if (driverVersion==1) { /* only LLD_SDHD cards implement this */
    buff[1] = sizeof(buf)-2; /* size of buffer */
    buff[0] = MMC_GET_LLD_CMD_HIGH_CAPACITY; /* cmd */
    if (disk_ioctl(0, MMC_GET_LLD_INFO, &buff[0])==RES_OK) {
      FSSH1_SendStatusStr((unsigned char*)"High capacity", (unsigned char*)(buff[2]!=0?"yes\r\n":"no\r\n"), io->stdOut);
    }
    buff[0] = MMC_GET_LLD_CMD_HIGH_SPEED; /* cmd */
    if (disk_ioctl(0, MMC_GET_LLD_INFO, &buff[0])==RES_OK) {
      FSSH1_SendStatusStr((unsigned char*)"High speed", (unsigned char*)(buff[2]!=0?"yes\r\n":"no\r\n"), io->stdOut);
    }
    buff[0] = MMC_GET_LLD_CMD_LOW_VOLTAGE; /* cmd */
    if (disk_ioctl(0, MMC_GET_LLD_INFO, &buff[0])==RES_OK) {
      FSSH1_SendStatusStr((unsigned char*)"Low voltage", (unsigned char*)(buff[2]!=0?"yes\r\n":"no\r\n"), io->stdOut);
    }
    buff[0] = MMC_GET_LLD_CMD_DATA_WIDTHS; /* cmd */
    if (disk_ioctl(0, MMC_GET_LLD_INFO, &buff[0])==RES_OK) {
      FSSH1_SendStatusStr((unsigned char*)"Data widths", (unsigned char*)"", io->stdOut);
      if (buff[2]&0x1) {
        FSSH1_SendStr((unsigned char*)"1 ", io->stdOut);
      }
      if (buff[2]&0x2) {
        FSSH1_SendStr((unsigned char*)"4 ", io->stdOut);
      }
      if (buff[2]&0x4) {
        FSSH1_SendStr((unsigned char*)"8 ", io->stdOut);
      }
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    }
    buff[0] = MMC_GET_LLD_CMD_OPERATIONS; /* cmd */
    if (disk_ioctl(0, MMC_GET_LLD_INFO, &buff[0])==RES_OK) {
      FSSH1_SendStatusStr((unsigned char*)"Operations", (unsigned char*)"", io->stdOut);
      if (buff[2]&0x1) {
        FSSH1_SendStr((unsigned char*)"BlockRead ", io->stdOut);
      }
      if (buff[2]&0x2) {
        FSSH1_SendStr((unsigned char*)"BlockWrite ", io->stdOut);
      }
      if (buff[2]&0x4) {
        FSSH1_SendStr((unsigned char*)"BlockErase ", io->stdOut);
      }
      if (buff[2]&0x8) {
        FSSH1_SendStr((unsigned char*)"WriteProtect ", io->stdOut);
      }
      if (buff[2]&0x10) {
        FSSH1_SendStr((unsigned char*)"I/O ", io->stdOut);
      }
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    }
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  CmdUsageError (component FSShell)
**
**     Description :
**         Called in case of an error using a command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void CmdUsageError(const unsigned char *cmd, byte *usage, FSSH1_ConstStdIOType *io)
{
  FSSH1_SendStr((unsigned char*)"*** error while reading command: ", io->stdErr);
  FSSH1_SendStr(cmd, io->stdErr);
  FSSH1_SendStr((unsigned char*)"\r\n*** Usage: ", io->stdErr);
  FSSH1_SendStr((unsigned char*)usage, io->stdErr);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdErr);
}

/*
** ===================================================================
**     Method      :  DirCmd (component FSShell)
**
**     Description :
**         Processes the directory command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte DirCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "dir" */
  byte res = ERR_OK;
  FSSH1_DEF_NAMEBUF(fileName);

  FSSH1_INIT_NAMEBUF(fileName);
  if (*(cmd+sizeof("dir")-1)== ' ') { /* space after "dir": read name */
    if (UTIL1_ReadEscapedName(cmd+sizeof("dir"), FSSH1_PTR_NAMEBUF(fileName),
          FSSH1_SIZE_NAMEBUF(fileName), NULL, NULL, NULL)==ERR_OK
       )
    {
      /* ok, have now directory name */
    } else {
      FSSH1_SendStr((unsigned char*)"reading directory name failed!\r\n", io->stdErr);
      res = ERR_FAILED;
    }
  } else { /* use current directory */
#if FAT1_FS_RPATH >= 2
    FAT1_FRESULT fres;
    fres = FAT1_getcwd((char*)FSSH1_PTR_NAMEBUF(fileName), FSSH1_SIZE_NAMEBUF(fileName));
    if(fres!=FR_OK) {
      FatFsFResultMsg((unsigned char*)"getcwd failed", fres, io);
      res = ERR_FAILED;
    } else {
      /* ok, have now directory name */
    }
#else
    UTIL1_strcpy(FSSH1_PTR_NAMEBUF(fileName), FSSH1_SIZE_NAMEBUF(fileName), (unsigned char*)"\\"); /* use root */
#endif
  }
  if (res == ERR_OK) {
    res = FSSH1_PrintDirectory(FSSH1_PTR_NAMEBUF(fileName), io);
  }
  FSSH1_FREE_NAMEBUF(fileName);
  return res;
}

/*
** ===================================================================
**     Method      :  CopyCmd (component FSShell)
**
**     Description :
**         Processes the copy command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte CopyCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "copy" */
  byte res = ERR_OK;
  size_t lenRead;
  FSSH1_DEF_NAMEBUF(fileName);
  FSSH1_DEF_NAMEBUF(fileName2);

  FSSH1_INIT_NAMEBUF(fileName);
  FSSH1_INIT_NAMEBUF(fileName2);
  if (   (UTIL1_ReadEscapedName(cmd+sizeof("copy"), FSSH1_PTR_NAMEBUF(fileName),
          FSSH1_SIZE_NAMEBUF(fileName), &lenRead, NULL, NULL)==ERR_OK)
      && *(cmd+sizeof("copy")+lenRead)==' '
      && (UTIL1_ReadEscapedName(cmd+sizeof("copy")+lenRead+1, FSSH1_PTR_NAMEBUF(fileName2),
          FSSH1_SIZE_NAMEBUF(fileName2), NULL, NULL, NULL)==ERR_OK)
     )
  {
    res = FSSH1_CopyFile(FSSH1_PTR_NAMEBUF(fileName), FSSH1_PTR_NAMEBUF(fileName2), io);
  } else {
    CmdUsageError(cmd, (unsigned char*)"copy srcFileName dstFileName", io);
    res = ERR_FAILED;
  }
  FSSH1_FREE_NAMEBUF(fileName);
  FSSH1_FREE_NAMEBUF(fileName2);
  return res;
}

/*
** ===================================================================
**     Method      :  DeleteCmd (component FSShell)
**
**     Description :
**         Processes the copy command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte DeleteCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "delete" */
  byte res = ERR_OK;
  FSSH1_DEF_NAMEBUF(fileName);

  FSSH1_INIT_NAMEBUF(fileName);
  if (UTIL1_ReadEscapedName(cmd+sizeof("delete"), FSSH1_PTR_NAMEBUF(fileName),
        FSSH1_SIZE_NAMEBUF(fileName), NULL, NULL, NULL)==ERR_OK
     )
  {
    res = FSSH1_DeleteFile(FSSH1_PTR_NAMEBUF(fileName), io);
  } else {
    CmdUsageError(cmd, (unsigned char*)"delete fileName", io);
    res = ERR_FAILED;
  }
  FSSH1_FREE_NAMEBUF(fileName);
  return res;
}

/*
** ===================================================================
**     Method      :  MkdirCmd (component FSShell)
**
**     Description :
**         Processes the mkdir command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte MkdirCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "mkdir" */
  byte res = ERR_OK;
  FSSH1_DEF_NAMEBUF(fileName);

  FSSH1_INIT_NAMEBUF(fileName);
  if (UTIL1_ReadEscapedName(cmd+sizeof("mkdir"), FSSH1_PTR_NAMEBUF(fileName),
        FSSH1_SIZE_NAMEBUF(fileName), NULL, NULL, NULL)==ERR_OK
     )
  {
    res = FSSH1_MakeDirectory(FSSH1_PTR_NAMEBUF(fileName), io);
  } else {
    CmdUsageError(cmd, (unsigned char*)"mkdir directoryName", io);
    res = ERR_FAILED;
  }
  FSSH1_FREE_NAMEBUF(fileName);
  return res;
}

/*
** ===================================================================
**     Method      :  RenameCmd (component FSShell)
**
**     Description :
**         Processes the mkdir command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte RenameCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "rename" */
  byte res = ERR_OK;
  size_t lenRead;
  FSSH1_DEF_NAMEBUF(fileName);
  FSSH1_DEF_NAMEBUF(fileName2);

  FSSH1_INIT_NAMEBUF(fileName);
  FSSH1_INIT_NAMEBUF(fileName2);
  if (   (UTIL1_ReadEscapedName(cmd+sizeof("rename"), FSSH1_PTR_NAMEBUF(fileName),
          FSSH1_SIZE_NAMEBUF(fileName), &lenRead, NULL, NULL)==ERR_OK)
      && *(cmd+sizeof("rename")+lenRead)==' '
      && (UTIL1_ReadEscapedName(cmd+sizeof("rename")+lenRead+1,
          FSSH1_PTR_NAMEBUF(fileName2),
          FSSH1_SIZE_NAMEBUF(fileName2), NULL, NULL, NULL)==ERR_OK)
     )
  {
    res = FSSH1_RenameFile((unsigned char*)FSSH1_PTR_NAMEBUF(fileName), (unsigned char*)FSSH1_PTR_NAMEBUF(fileName2), io);
  } else {
    CmdUsageError(cmd, (unsigned char*)"rename srcFileName dstFileName", io);
    res = ERR_FAILED;
  }
  FSSH1_FREE_NAMEBUF(fileName);
  FSSH1_FREE_NAMEBUF(fileName2);
  return res;
}

/*
** ===================================================================
**     Method      :  PrintCmd (component FSShell)
**
**     Description :
**         Processes the print command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte PrintCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "print" */
  byte res = ERR_OK;
  FSSH1_DEF_NAMEBUF(fileName);

  FSSH1_INIT_NAMEBUF(fileName);
  if (UTIL1_ReadEscapedName(cmd+sizeof("print"), FSSH1_PTR_NAMEBUF(fileName),
        FSSH1_SIZE_NAMEBUF(fileName), NULL, NULL, NULL)==ERR_OK
     )
  {
    res = FSSH1_PrintFile(FSSH1_PTR_NAMEBUF(fileName), io);
  } else {
    CmdUsageError(cmd, (unsigned char*)"print fileName", io);
    res = ERR_FAILED;
  }
  FSSH1_FREE_NAMEBUF(fileName);
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_ChangeDirectory (component FSShell)
**
**     Description :
**         Changes to a directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         dirName         - Directory name
**       * io              - Pointer to I/O callback routines
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_ChangeDirectory(const byte *dirName, FSSH1_ConstStdIOType *io)
{
#if FAT1_FS_RPATH > 0
  FAT1_FRESULT fres;

  if ((fres=FAT1_chdir((char*)dirName)) != FR_OK) {
    FatFsFResultMsg((unsigned char*)"chdir failed", fres, io);
    return ERR_FAILED;
  }
  return ERR_OK;
#else
  (void)dirName;
  #warning "relative directories not enabled in FatFS!"
  FSSH1_SendStr((unsigned char*)"cd command not available as relative directories not enable in file system\r\n", io->stdErr);
  return ERR_FAILED;
#endif
}

/*
** ===================================================================
**     Method      :  CdCmd (component FSShell)
**
**     Description :
**         Changes the current directory
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte CdCmd(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd starts with "cd" */
#if FAT1_FS_RPATH > 0
  byte res = ERR_OK;
  FSSH1_DEF_NAMEBUF(fileName);

  FSSH1_INIT_NAMEBUF(fileName);
  if (*(cmd+sizeof("cd")-1)== ' ') { /* space after "cd": read name */
    if (UTIL1_ReadEscapedName(cmd+sizeof("cd"), FSSH1_PTR_NAMEBUF(fileName),
          FSSH1_SIZE_NAMEBUF(fileName), NULL, NULL, NULL)==ERR_OK
       )
    {
      res = FSSH1_ChangeDirectory(FSSH1_PTR_NAMEBUF(fileName), io);
    } else {
      FSSH1_SendStr((unsigned char*)"reading directory name failed!\r\n", io->stdErr);
      res = ERR_FAILED;
    }
  } else { /* print current directory */
#if FAT1_FS_RPATH >= 2
    FAT1_FRESULT fres;

    fres = FAT1_getcwd((char*)FSSH1_PTR_NAMEBUF(fileName), FSSH1_SIZE_NAMEBUF(fileName));
    if(fres!=FR_OK) {
      FatFsFResultMsg((unsigned char*)"getcwd failed", fres, io);
      res = ERR_FAILED;
    } else {
      FSSH1_SendStr(FSSH1_PTR_NAMEBUF(fileName), io->stdOut);
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    }
#else
    UTIL1_strcpy(FSSH1_PTR_NAMEBUF(fileName), FSSH1_SIZE_NAMEBUF(fileName), (unsigned char*)"\\"); /* use root */
#endif
  }
  FSSH1_FREE_NAMEBUF(fileName);
  return res;
#else
  (void)cmd;
  #warning "relative directories not enabled in FatFS!"
  FSSH1_SendStr((unsigned char*)"relative directories not available in file system\r\n", io->stdErr);
  return ERR_FAILED;
#endif
}

/*
** ===================================================================
**     Method      :  AddSWRTCDate (component FSShell)
**
**     Description :
**         Adds a date from the software RTC to a string
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte AddSWRTCDate(byte *buf, word bufSize)
{
  DATEREC date;

  if (TmDt1_GetDate(&date)!=ERR_OK) {
    return ERR_FAILED;
  }
  UTIL1_strcatNum16uFormatted(buf, bufSize, date.Day, '0', 2);
  UTIL1_chcat(buf, bufSize, '.');
  UTIL1_strcatNum16uFormatted(buf, bufSize, date.Month, '0', 2);
  UTIL1_chcat(buf, bufSize, '.');
  UTIL1_strcatNum16u(buf, bufSize, date.Year);
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  AddSWRTCTime (component FSShell)
**
**     Description :
**         Adds a time from the software RTC to a string
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static byte AddSWRTCTime(byte *buf, word bufSize)
{
  TIMEREC time;

  if (TmDt1_GetTime(&time)!=ERR_OK) {
    return ERR_FAILED;
  }
  UTIL1_strcatNum16sFormatted(buf, bufSize, time.Hour, '0', 2);
  UTIL1_chcat(buf, bufSize, ':');
  UTIL1_strcatNum16sFormatted(buf, bufSize, time.Min, '0', 2);
  UTIL1_chcat(buf, bufSize, ':');
  UTIL1_strcatNum16sFormatted(buf, bufSize, time.Sec, '0', 2);
  UTIL1_chcat(buf, bufSize, ',');
  UTIL1_strcatNum16sFormatted(buf, bufSize, time.Sec100, '0', 2);
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_Date (component FSShell)
**
**     Description :
**         Processes the date command
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cmd             - Pointer to command string
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_Date(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  /* precondition: cmd points to "date" */
  byte day, month;
  word year;
  const unsigned char *p;
  byte res = ERR_OK;

  p = cmd + sizeof("date")-1;
  if (*p==' ') { /* ok, have an argument */
    if (UTIL1_ScanDate(&p, &day, &month, &year) == ERR_OK) { /* ok, format fine */
      if (TmDt1_SetDate(year, month, day) != ERR_OK) {
        FSSH1_SendStr((unsigned char*)"***Failed to set date\r\n", io->stdErr);
        res = ERR_FAILED;
      } else {
      }
    } else {
      FSSH1_SendStr((unsigned char*)"*** error while reading command! ***", io->stdErr);
      FSSH1_SendStr((void *)cmd, io->stdErr);
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdErr);
      res = ERR_FAILED;
    }
  } /* has an argument */
  /* print now current date */
  if (res==ERR_OK) {
    unsigned char buf[sizeof("SW date dd:mm:yyyy\\r\\n")];

    UTIL1_strcpy(buf, sizeof(buf), (unsigned char*)"SW date ");
    if (AddSWRTCDate(buf, sizeof(buf))!=ERR_OK) {
      FSSH1_SendStr((unsigned char*)"***Failed to get SW RTC date\r\n", io->stdErr);
      res = ERR_FAILED;
    } else {
      UTIL1_strcat(buf, sizeof(buf), (unsigned char*)"\r\n");
      FSSH1_SendStr(buf, io->stdOut);
    }
  }
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_Time (component FSShell)
**
**     Description :
**         Processes the time command
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cmd             - Pointer to command string
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_Time(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  byte hour, minute, second, hSecond;
  const unsigned char *p;
  byte res = ERR_OK;

  p = cmd + sizeof("time")-1;
  if (*p==' ') { /* has an argument */
    if (UTIL1_ScanTime(&p, &hour, &minute, &second, &hSecond)==ERR_OK) { /* format fine */
      /* set SW RTC time */
      if (TmDt1_SetTime((byte)hour, (byte)minute, (byte)second, hSecond) != ERR_OK) {
        FSSH1_SendStr((unsigned char*)"***Failed to set SW RTC time\r\n", io->stdErr);
        res = ERR_FAILED;
      }
    } else {
      FSSH1_SendStr((unsigned char*)"*** error while reading command: ", io->stdErr);
      FSSH1_SendStr(cmd, io->stdErr);
      FSSH1_SendStr((unsigned char*)"\r\n", io->stdErr);
      res = ERR_FAILED;
    }
  }
  /* print now current time */
  if (res==ERR_OK) {
    unsigned char buf[sizeof("SW time hh:mm:ss.hh\\r\\n")];

    UTIL1_strcpy(buf, sizeof(buf), (unsigned char*)"SW time ");
    if (AddSWRTCTime(buf, sizeof(buf))!=ERR_OK) {
      FSSH1_SendStr((unsigned char*)"***Failed to get SW RTC time\r\n", io->stdErr);
      res = ERR_FAILED;
    } else {
      UTIL1_strcat(buf, sizeof(buf), (unsigned char*)"\r\n");
      FSSH1_SendStr(buf, io->stdOut);
    }
  }
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_ShellCmd (component FSShell)
**
**     Description :
**         Parses a shell command. Use 'help' to get a list of
**         supported commands.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cmd             - Pointer to command string
**       * handled         - Pointer to variable to indicate if
**                           the command has been handled. The caller
**                           passes this variable to the command scanner
**                           to find out if the passed command has been
**                           handled. The variable is initialized by the
**                           caller.
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_ShellCmd(const unsigned char *cmd, bool *handled, FSSH1_ConstStdIOType *io)
{
  if (UTIL1_strcmp((char*)cmd, FSSH1_CMD_HELP)==0 || UTIL1_strcmp((char*)cmd, "shell help")==0) {
    FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    FSSH1_SendStr((unsigned char*)"Tower-Kinetis K60", io->stdOut);
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
    FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"shell", (const unsigned char*)"Group of shell commands\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  help|status", (const unsigned char*)"Print help or status information\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  cd [<directoryName>]", (const unsigned char*)"Change the current directory or display the name of the current directory\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  dir [<directoryName>]", (const unsigned char*)"Prints a directory\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  copy <src> <dst>", (const unsigned char*)"Copy a file\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  delete <filename>", (const unsigned char*)"Delete a file\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  mkdir <directory>", (const unsigned char*)"Create a directory\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  rename <src> <dst>", (const unsigned char*)"Rename a file\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  print <filename>", (const unsigned char*)"Print a file\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  diskinfo", (const unsigned char*)"Prints disk information\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  time [hh:mm:ss[,z]]", (const unsigned char*)"Set the current time. Print the current time if no argument\r\n", io->stdOut);
    FSSH1_SendHelpStr((unsigned char*)"  date [dd.mm.yyyy]", (const unsigned char*)"Set the current date. Prints the current date if no argument\r\n", io->stdOut);
    *handled = TRUE;
    return ERR_OK;
  } else if (UTIL1_strncmp((char*)cmd, "cd", sizeof("cd")-1)==0) {
    *handled = TRUE;
    return CdCmd(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "dir", sizeof("dir")-1)==0) {
    *handled = TRUE;
    return DirCmd(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "copy", sizeof("copy")-1)==0) {
    *handled = TRUE;
    return CopyCmd(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "delete", sizeof("delete")-1)==0) {
    *handled = TRUE;
    return DeleteCmd(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "mkdir", sizeof("mkdir")-1)==0) {
    *handled = TRUE;
    return MkdirCmd(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "rename", sizeof("rename")-1)==0) {
    *handled = TRUE;
    return RenameCmd(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "print", sizeof("print")-1)==0) {
    *handled = TRUE;
    return PrintCmd(cmd, io);
  } else if ((UTIL1_strcmp((char*)cmd, FSSH1_CMD_STATUS)==0) || (UTIL1_strcmp((char*)cmd, "shell status")==0)) {
    *handled = TRUE;
    return FSSH1_PrintStatus(io);
  } else if (UTIL1_strcmp((char*)cmd, "diskinfo")==0) {
    *handled = TRUE;
    return FSSH1_PrintDiskInfo(0, io);
  } else if (UTIL1_strncmp((char*)cmd, "date", sizeof("date")-1)==0) {
    *handled = TRUE;
    return FSSH1_Date(cmd, io);
  } else if (UTIL1_strncmp((char*)cmd, "time", sizeof("time")-1)==0) {
    *handled = TRUE;
    return FSSH1_Time(cmd, io);
  }
  return ERR_OK; /* no error */
}

/*
** ===================================================================
**     Method      :  FSSH1_PrintPrompt (component FSShell)
**
**     Description :
**         Prints the prompt to the stdOut channel
**     Parameters  :
**         NAME            - DESCRIPTION
**       * io              - Pointer to IO to be used
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_PrintPrompt(FSSH1_ConstStdIOType *io)
{
  FSSH1_SendStr((unsigned char*)"CMD> ", io->stdOut);
}

/*
** ===================================================================
**     Method      :  FSSH1_ReadLine (component FSShell)
**
**     Description :
**         Reads a line from stdIn and returns TRUE if we have a line,
**         FALSE otherwise.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * buf             - Pointer to buffer where to read in the
**                           information
**         bufSize         - size of buffer
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
bool FSSH1_ReadLine(byte *buf, size_t bufSize, FSSH1_ConstStdIOType *io)
{
  byte c;

  if (io->keyPressed()) {
    *buf = '\0'; /* init buffer */
    /* now read in line */
    do {                               /* while not '\r' or '\n' */
      io->stdIn(&c);                   /* read character */
      io->stdOut(c);                   /* echo character */
      *buf++ = (byte)c;                /* append character to the string */
      bufSize--;
      if (bufSize <= 1) {              /* buffer full */
        buf++;
        break;
      }
    } while ((c!='\r') && (c!='\n') && (c!='\0'));
    *--buf = '\0';                     /* zero terminate string */
    return TRUE;
  } else {
    return FALSE;
  }
}

/*
** ===================================================================
**     Method      :  FSSH1_CheckCardPresence (component FSShell)
**
**     Description :
**         This method checks if card has been inserted or removed and
**         mounts or unmounts the file system.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cardMounted     - Pointer to initialize this
**                           variable to FALSE on the caller side the
**                           first time.
**         drive           - drive number, pass 0 as default drive
**       * fileSystemObject - Pointer to 
**       * io              - Pointer to io handler to be used
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_CheckCardPresence(bool *cardMounted, byte drive, FSSH1_FATFS *fileSystemObject, FSSH1_ConstStdIOType *io)
{
  if (!(*cardMounted) && FAT1_isDiskPresent()) {
    /* card inserted */
    if (FSSH1_MountFileSystem(fileSystemObject, drive, io)==ERR_OK) {
      *cardMounted = TRUE;
      FSSH1_SendStr((unsigned char*)"File System mounted\r\n", io->stdOut);
    } else {
      return ERR_FAILED;
    }
  } else if (*cardMounted && !FAT1_isDiskPresent()) {
    /* card removed */
    if (FSSH1_UnMountFileSystem(drive, io)==ERR_OK) {
      *cardMounted = FALSE;
      FSSH1_SendStr((unsigned char*)"File System unmounted\r\n", io->stdOut);
    } else {
      return ERR_FAILED;
    }
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_PrintStatus (component FSShell)
**
**     Description :
**         Prints various available system status information
**     Parameters  :
**         NAME            - DESCRIPTION
**       * io              - Pointer to I/O callbacks
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_PrintStatus(FSSH1_ConstStdIOType *io)
{
  byte res = ERR_OK;
  byte buf[16];
#if configUSE_TRACE_FACILITY || configGENERATE_RUN_TIME_STATS /* FreeRTOS trace feature enabled */
  unsigned char *taskListBufferP;
  size_t bufSize;
#endif

  FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
  FSSH1_SendStr((unsigned char*)"\r\nSYSTEM STATUS\r\n", io->stdOut);
  FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
#if configUSE_TRACE_FACILITY /* FreeRTOS trace feature enabled */
  FSSH1_SendStr((unsigned char*)"TASK LIST:\r\nName\t\tStatus\tPrio\tStack\tTCB#\r\n", io->stdOut);
  FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
  /* task list and status */
  bufSize = 40*uxTaskGetNumberOfTasks();  /* about 40 bytes for a task should be enough */
  taskListBufferP = FRTOS1_pvPortMalloc(bufSize); /* about 40 bytes for a task should be enough */
  if (taskListBufferP != NULL) {
    FRTOS1_vTaskList((portCHAR*)taskListBufferP, bufSize);
    FSSH1_SendStr(taskListBufferP, io->stdOut);
    FRTOS1_vPortFree(taskListBufferP);
  }
#endif
#if configGENERATE_RUN_TIME_STATS
  FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
  FSSH1_SendStr((unsigned char*)"\r\nRTOS RUN-TIME STATISTICS:\r\nName\tTime (ms)\t%Time\r\n", io->stdOut);
  FSSH1_SendStr((unsigned char*)FSSH1_DASH_LINE, io->stdOut);
  /* task list and status */
  bufSize = 40*uxTaskGetNumberOfTasks();  /* about 40 bytes for a task should be enough */
  taskListBufferP = FRTOS1_pvPortMalloc(bufSize);
  if (taskListBufferP != NULL) {
    FRTOS1_vTaskGetRunTimeStats((portCHAR*)taskListBufferP, bufSize);
    FSSH1_SendStr(taskListBufferP, io->stdOut);
    FRTOS1_vPortFree(taskListBufferP);
  }
#endif
  FSSH1_SendStatusStr((unsigned char*)"RTOS ticks", (const unsigned char*)"", io->stdOut);
  UTIL1_Num16sToStr(buf, sizeof(buf), configTICK_RATE_HZ);
  FSSH1_SendStr(buf, io->stdOut);
  FSSH1_SendStr((unsigned char*)" Hz, ", io->stdOut);
  UTIL1_Num16sToStr(buf, sizeof(buf), 1000/configTICK_RATE_HZ);
  FSSH1_SendStr(buf, io->stdOut);
  FSSH1_SendStr((unsigned char*)" ms\r\n", io->stdOut);
  FSSH1_SendStatusStr((unsigned char*)"Free heap", (const unsigned char*)"", io->stdOut);
  UTIL1_Num32uToStr(buf, sizeof(buf), FRTOS1_xPortGetFreeHeapSize());
  FSSH1_SendStr(buf, io->stdOut);
  FSSH1_SendStr((unsigned char*)" bytes\r\n", io->stdOut);
  FSSH1_SendStatusStr((const unsigned char*)"Firmware", (const unsigned char*)__DATE__, io->stdOut);
  FSSH1_SendStr((unsigned char*)" ", io->stdOut);
  FSSH1_SendStr((unsigned char*)__TIME__, io->stdOut);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  FSSH1_SendStatusStr((unsigned char*)"SW RTC", (const unsigned char*)"", io->stdOut);
  buf[0] = '\0';
  if (AddSWRTCDate(buf, sizeof(buf))!=ERR_OK) {
    FSSH1_SendStr((unsigned char*)"***Failed to get SW RTC date! ", io->stdErr);
    res = ERR_FAILED;
  } else {
    FSSH1_SendStr(buf, io->stdOut);
  }
  UTIL1_strcpy(buf, sizeof(buf), (unsigned char*)" ");
  if (AddSWRTCTime(buf, sizeof(buf))!=ERR_OK) {
    FSSH1_SendStr((unsigned char*)"***Failed to get SW RTC time! ", io->stdErr);
  } else {
    FSSH1_SendStr(buf, io->stdOut);
  }
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdOut);
  if (FAT1_isDiskPresent()) {
    FSSH1_SendStatusStr((unsigned char*)"SD present", (unsigned char*)"yes\r\n", io->stdOut);
  } else {
    FSSH1_SendStatusStr((unsigned char*)"SD present", (unsigned char*)"no\r\n", io->stdOut);
  }
  if (FAT1_isWriteProtected()) {
    FSSH1_SendStatusStr((unsigned char*)"SD protected", (unsigned char*)"yes\r\n", io->stdOut);
  } else {
    FSSH1_SendStatusStr((unsigned char*)"SD protected", (unsigned char*)"no\r\n", io->stdOut);
  }
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_PrintCommandFailed (component FSShell)
**
**     Description :
**         Prints a standard message for failed or unknown commands
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cmd             - Pointer to command which was failing
**       * io              - Pointer to I/O callbacks
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_PrintCommandFailed(const unsigned char *cmd, FSSH1_ConstStdIOType *io)
{
  FSSH1_SendStr((unsigned char*)"*** Failed or unknown command: ", io->stdErr);
  FSSH1_SendStr(cmd, io->stdErr);
  FSSH1_SendStr((unsigned char*)"\r\n", io->stdErr);
  FSSH1_SendStr((unsigned char*)"*** Type ", io->stdErr);
  FSSH1_SendStr((unsigned char*)FSSH1_CMD_HELP, io->stdErr);
  FSSH1_SendStr((unsigned char*)" to get a list of available commands\r\n", io->stdErr);
}

/*
** ===================================================================
**     Method      :  FSSH1_ParseCommand (component FSShell)
**
**     Description :
**         Parses a shell command. It handles first the internal
**         commands and will call the provided callback.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cmd             - Pointer to command string
**       * io              - Pointer to I/O callbacks
**         parseCallback   - callback which will be
**                           called to parse commands in the user
**                           application, or NULL if not used.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_ParseCommand(const unsigned char *cmd, FSSH1_ConstStdIOType *io, FSSH1_ParseCommandCallback parseCallback)
{
  bool handled;
  bool silent;

  if (*cmd=='\0') { /* empty command */
    return ERR_OK;
  }
  /* parse first shell commands */
  handled = FALSE;
  silent = (bool)(*cmd=='#');
  if (silent) {
    cmd++; /* skip '#' */
  }
  if (FSSH1_ShellCmd(cmd, &handled, io)!=ERR_OK) {
    return ERR_FAILED;
  }
  /* parse application commands */
  if ((parseCallback!=NULL && parseCallback(cmd, &handled, io)!=ERR_OK) || !handled) { /* call other handlers */
    FSSH1_PrintCommandFailed(cmd, io);
    return ERR_FAILED;
  }
  if (!silent) {
    FSSH1_PrintPrompt(io);
  }
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  FSSH1_GetStdio (component FSShell)
**
**     Description :
**         Returns the default stdio channel. This method is only
**         available if a shell is enabled in the component properties.
**     Parameters  : None
**     Returns     :
**         ---             - Pointer to the stdio descriptor
** ===================================================================
*/
FSSH1_ConstStdIOTypePtr FSSH1_GetStdio(void)
{
  static FSSH1_ConstStdIOType FSSH1_stdio =
  {
    (FSSH1_StdIO_In_FctType)FSSH1_ReadChar, /* stdin */
    (FSSH1_StdIO_OutErr_FctType)FSSH1_SendChar, /* stdout */
    (FSSH1_StdIO_OutErr_FctType)FSSH1_SendChar, /* stderr */
    FSSH1_KeyPressed /* if input is not empty */
  };

  return &FSSH1_stdio;
}

/*
** ===================================================================
**     Method      :  FSSH1_ReadAndParseCmd (component FSShell)
**
**     Description :
**         Reads a command line from the default io channel and parses
**         if.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * cmdBuf          - Pointer to buffer provided by the
**                           caller where to store the command to read in
**         cmdBufSize      - 
**       * io              - Pointer to I/O channels to be used
**         parseCallback   - callback provided by
**                           the user application to parse user commands.
**                           If not used, NULL can be passed.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte FSSH1_ReadAndParseCmd(byte *cmdBuf, size_t cmdBufSize, FSSH1_ConstStdIOType *io, FSSH1_ParseCommandCallback parseCallback)
{
  byte res = ERR_OK;

  if (FSSH1_ReadLine(cmdBuf, cmdBufSize, io)) {
    res = FSSH1_ParseCommand(cmdBuf, io, parseCallback);
  }
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_RequestSerial (component FSShell)
**
**     Description :
**         Used to get mutual access to the shell console. Only has an
**         effect if using an RTOS with semaphore for the console
**         access.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_RequestSerial(void)
{
  (void)FRTOS1_xSemaphoreTakeRecursive(ShellSem, portMAX_DELAY);
}

/*
** ===================================================================
**     Method      :  FSSH1_ReleaseSerial (component FSShell)
**
**     Description :
**         Used to release mutual access to the shell console. Only has
**         an effect if using an RTOS with semaphore for the console
**         access.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_ReleaseSerial(void)
{
  (void)FRTOS1_xSemaphoreGiveRecursive(ShellSem);
}

/*
** ===================================================================
**     Method      :  FSSH1_GetSemaphore (component FSShell)
**
**     Description :
**         Return the semaphore of the shell.
**     Parameters  : None
**     Returns     :
**         ---             - semaphore, or NULL if not used or not
**                           allocated.
** ===================================================================
*/
void* FSSH1_GetSemaphore(void)
{
  return ShellSem;
}

/*
** ===================================================================
**     Method      :  SendSeparatedStrings (component FSShell)
**
**     Description :
**         Prints a string using an I/O function, formated for the 'help' 
**         command
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void SendSeparatedStrings(const byte *strA, const byte *strB, byte tabChar, byte tabPos, FSSH1_StdIO_OutErr_FctType io)
{
  /* write command part */
  while(*strA!='\0' && tabPos>0) {
    io(*strA++);
    tabPos--;
  }
  /* fill up until ';' */
  while(tabPos>0) {
    io(' ');
    tabPos--;
  }
  /* write separator */
  io(tabChar);
  io(' ');
  /* write help text */
  FSSH1_SendStr(strB, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendHelpStr (component FSShell)
**
**     Description :
**         Prints a string using an I/O function, formated for the
**         'help' command
**     Parameters  :
**         NAME            - DESCRIPTION
**       * strCmd          - Pointer to string of the command
**       * strHelp         - Pointer to help text string
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendHelpStr(const byte *strCmd, const byte *strHelp, FSSH1_StdIO_OutErr_FctType io)
{
  #define HELP_SEMICOLON_POS  26 /* position of the ';' after the command string */
  SendSeparatedStrings(strCmd, strHelp, ';', HELP_SEMICOLON_POS, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendStatusStr (component FSShell)
**
**     Description :
**         Prints a status string using an I/O function, formated for
**         the 'status' command
**     Parameters  :
**         NAME            - DESCRIPTION
**       * strItem         - Pointer to string of the command
**       * strStatus       - Pointer to help text string
**         io              - I/O callbacks to be used for printing.
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendStatusStr(const byte *strItem, const byte *strStatus, FSSH1_StdIO_OutErr_FctType io)
{
  #define STATUS_COLON_POS  13 /* position of the ':' after the item string */
  SendSeparatedStrings(strItem, strStatus, ':', STATUS_COLON_POS, io);
}

/*
** ===================================================================
**     Method      :  FSSH1_ReadChar (component FSShell)
**
**     Description :
**         Reads a character (blocking)
**     Parameters  :
**         NAME            - DESCRIPTION
**       * c               - Pointer to character to be used to store the
**                           result
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_ReadChar(byte *c)
{
  (void)FRTOS1_xSemaphoreTakeRecursive(ShellSem, portMAX_DELAY);
  /* {FreeRTOS RTOS Adapter} Critical section begin (RTOS function call is defined by FreeRTOS RTOS Adapter property) */
  taskENTER_CRITICAL();
  *c = serialRxBuf[serialRxOutIdx];
  serialRxOutIdx++;
  if (serialRxOutIdx==sizeof(serialRxBuf)) { /* wrap over */
    serialRxOutIdx = 0;
  }
  /* {FreeRTOS RTOS Adapter} Critical section ends (RTOS function call is defined by FreeRTOS RTOS Adapter property) */
  taskEXIT_CRITICAL();
  (void)FRTOS1_xSemaphoreGiveRecursive(ShellSem);
}

/*
** ===================================================================
**     Method      :  FSSH1_SendChar (component FSShell)
**
**     Description :
**         Sends a character (blocking)
**     Parameters  :
**         NAME            - DESCRIPTION
**         ch              - character to be sent
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_SendChar(byte ch)
{
  (void)FRTOS1_xSemaphoreTakeRecursive(ShellSem, portMAX_DELAY);
  FSSH1_SentFlag = 0; /* this will be set to 1 once the block has been sent */
  while(AS1_SendBlock(serialHandle, (LDD_TData*)&ch, 1)!=ERR_OK) {} /* Send char */
  while(FSSH1_SentFlag==0) {} /* wait until we get the green flag from the TX interrupt */
  (void)FRTOS1_xSemaphoreGiveRecursive(ShellSem);
}

/*
** ===================================================================
**     Method      :  FSSH1_KeyPressed (component FSShell)
**
**     Description :
**         Checks if a key has been pressed (a character is present in
**         the input buffer)
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
bool FSSH1_KeyPressed(void)
{
  bool res;
  (void)FRTOS1_xSemaphoreTakeRecursive(ShellSem, portMAX_DELAY);
  /* {FreeRTOS RTOS Adapter} Critical section begin (RTOS function call is defined by FreeRTOS RTOS Adapter property) */
  taskENTER_CRITICAL();
  res = serialRxInIdx!=serialRxOutIdx;
  /* {FreeRTOS RTOS Adapter} Critical section ends (RTOS function call is defined by FreeRTOS RTOS Adapter property) */
  taskEXIT_CRITICAL();
  (void)FRTOS1_xSemaphoreGiveRecursive(ShellSem);
  return res;
}

/*
** ===================================================================
**     Method      :  FSSH1_Init (component FSShell)
**
**     Description :
**         Initializes the module, especially creates the mutex
**         semaphore if an RTOS is used.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_Init(void)
{
  ShellSem = FRTOS1_xSemaphoreCreateRecursiveMutex();
  if (ShellSem==NULL) { /* semaphore creation failed */
    for(;;) {} /* error, not enough memory? */
  }
  /* initialize logical device driver */
  serialHandle = AS1_Init(NULL);
  /* set up to receive RX into input buffer */
  serialRxInIdx = serialRxOutIdx = 0;
  while(AS1_ReceiveBlock(serialHandle, (LDD_TData *)&serialRxBuf[0], 1)!=ERR_OK) {}
  FAT1_Init();
}

/*
** ===================================================================
**     Method      :  FSSH1_Deinit (component FSShell)
**
**     Description :
**         De-Initializes the module, especially frees the mutex
**         semaphore if an RTOS is used.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void FSSH1_Deinit(void)
{
  FRTOS1_vSemaphoreDelete(ShellSem);
  FAT1_Deinit();
  /* de-initialize logical device driver */
  AS1_Deinit(serialHandle);
}

/*
** ===================================================================
**     Method      :  FSSH1_OnBlockReceived (component FSShell)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void AS1_OnBlockReceived(LDD_TUserData *UserDataPtr)
{
  (void)UserDataPtr; /* argument not used */
  /* {FreeRTOS RTOS Adapter} Critical section begin (RTOS function call is defined by FreeRTOS RTOS Adapter property) */
  taskENTER_CRITICAL();
  /* New character already has been placed into buffer by the caller.
     Move forward in buffer and reserve space for next one. */
  serialRxInIdx++;
  if (serialRxInIdx==sizeof(serialRxBuf)) { /* wrap over */
    serialRxInIdx = 0;
  }
  if (serialRxInIdx==serialRxOutIdx) {
    /* getting data faster than we are able to consume! */
  }
  /* {FreeRTOS RTOS Adapter} Critical section ends (RTOS function call is defined by FreeRTOS RTOS Adapter property) */
  taskEXIT_CRITICAL();
  (void)AS1_ReceiveBlock(serialHandle, (LDD_TData *)&serialRxBuf[serialRxInIdx], 1);
}

/*
** ===================================================================
**     Method      :  FSSH1_OnBlockSent (component FSShell)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void AS1_OnBlockSent(LDD_TUserData *UserDataPtr)
{
  (void)UserDataPtr; /* unused argument */
  FSSH1_SentFlag = 1; /* set flag so sender knows we have finished */
}

/* END FSSH1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
