/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : LED3.c
**     Project     : ProcessorExpert
**     Processor   : MK60DN512ZVMD10
**     Component   : LED
**     Version     : Component 01.045, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-07-29, 20:29, # CodeGen: 367
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         On     - void LED3_On(void);
**         Off    - void LED3_Off(void);
**         Neg    - void LED3_Neg(void);
**         Get    - byte LED3_Get(void);
**         Put    - void LED3_Put(byte val);
**         Init   - void LED3_Init(void);
**         Deinit - void LED3_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software implementing an LED driver using Processor Expert.
**     This is a free software and is opened for education,  research and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE LED3. */

#include "LED3.h"

/*
** ===================================================================
**     Method      :  LED3_On (component LED)
**
**     Description :
**         This turns the LED on.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED3_On(void)
{
  GPIO1_ClearPortBits(NULL, GPIO1_LED_E3_MASK);
}

/*
** ===================================================================
**     Method      :  LED3_Off (component LED)
**
**     Description :
**         This turns the LED off.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED3_Off(void)
{
  GPIO1_SetPortBits(NULL, GPIO1_LED_E3_MASK);
}

/*
** ===================================================================
**     Method      :  LED3_Neg (component LED)
**
**     Description :
**         This negates/toggles the LED
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED3_Neg(void)
{
  GPIO1_TogglePortBits(NULL, GPIO1_LED_E3_MASK);
}

/*
** ===================================================================
**     Method      :  LED3_Get (component LED)
**
**     Description :
**         This returns logical 1 in case the LED is on, 0 otherwise.
**     Parameters  : None
**     Returns     :
**         ---             - Status of the LED (on or off)
** ===================================================================
*/
byte LED3_Get(void)
{
  return (byte)!((GPIO1_GetPortValue(NULL)&GPIO1_LED_E3_MASK)!=0);
}

/*
** ===================================================================
**     Method      :  LED3_Init (component LED)
**
**     Description :
**         Performs the LED driver initialization.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED3_Init(void)
{
  LED3_Off();
}

/*
** ===================================================================
**     Method      :  LED3_Put (component LED)
**
**     Description :
**         Turns the LED on or off.
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - value to define if the LED has to be on or
**                           off.
**     Returns     : Nothing
** ===================================================================
*/
void LED3_Put(byte val)
{
  if(val) {
    LED3_On();
  } else {
    LED3_Off();
  }
}

/*
** ===================================================================
**     Method      :  LED3_Deinit (component LED)
**
**     Description :
**         Deinitializes the driver
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED3_Deinit(void)
{
  GPIO1_Deinit(NULL);
}

/* END LED3. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
