/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : RTOSTRC1.c
**     Project     : ProcessorExpert
**     Processor   : MK60DN512ZVMD10
**     Component   : FreeRTOSTrace
**     Version     : Component 01.002, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-07-23, 09:29, # CodeGen: 359
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         Reserve   - void RTOSTRC1_Reserve(void);
**         Unreserve - void RTOSTRC1_Unreserve(void);
**         Select    - byte RTOSTRC1_Select(void);
**         Unselect  - byte RTOSTRC1_Unselect(void);
**         SendByte  - byte RTOSTRC1_SendByte(byte val);
**         Enable    - void RTOSTRC1_Enable(void);
**         Disable   - void RTOSTRC1_Disable(void);
**         Init      - void RTOSTRC1_Init(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger/Martin Bucher, 2012, all rights reserved.
**     This an open source software implementation with Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE RTOSTRC1. */
#include "FreeRTOS.h"
#include "RTOSTRC1.h"

static bool enableTrace = TRUE;
/*
** ===================================================================
**     Method      :  RTOSTRC1_Reserve (component FreeRTOSTrace)
**
**     Description :
**         Reserves the resource
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTOSTRC1_Reserve(void)
{
  /* If you see this comment in generated code, it means that method is not implemented yet ... */
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_Unreserve (component FreeRTOSTrace)
**
**     Description :
**         Unreserves the resource
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTOSTRC1_Unreserve(void)
{
  /* If you see this comment in generated code, it means that method is not implemented yet ... */
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_Select (component FreeRTOSTrace)
**
**     Description :
**         Select the communication channel
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTOSTRC1_Select(void)
{
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_Unselect (component FreeRTOSTrace)
**
**     Description :
**         Unselect the communication channel
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTOSTRC1_Unselect(void)
{
  return ERR_OK;
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_SendByte (component FreeRTOSTrace)
**
**     Description :
**         Send a Byte to the Probe
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - The byte to be sent
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RTOSTRC1_SendByte(byte val)
{

  if(enableTrace) {
    /* no communication channel selected? */
    return ERR_DISABLED;
  } else {
    (void)val;
    return ERR_DISABLED;
  }
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_Enable (component FreeRTOSTrace)
**
**     Description :
**         Enable the trace to the Probe
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTOSTRC1_Enable(void)
{
  enableTrace = TRUE;
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_Disable (component FreeRTOSTrace)
**
**     Description :
**         Disable the trace to the Probe must called before the
**         FreeRTOS method task create is called
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTOSTRC1_Disable(void)
{
  enableTrace = FALSE;
}

/*
** ===================================================================
**     Method      :  RTOSTRC1_Init (component FreeRTOSTrace)
**
**     Description :
**         Init the Component 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RTOSTRC1_Init(void)
{
 /* Nothing to init */
}

/* END RTOSTRC1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
